## libnetaid 1.5.3

=== Makefile ===
ROOT_DIR := $(shell dirname "$(realpath $(lastword $(MAKEFILE_LIST)))")
BUILD    ?= $(ROOT_DIR)/build

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null || true)

PREFIX ?= /usr/local
DESTDIR ?= /
INCLUDE_PREFIX ?= $(PREFIX)

CC	    ?= cc
CFLAGS ?= -Wall -Wextra -O2 -std=gnu99 -g -fPIC
LIBINC   := -I$(BUILD)

CFLAGS += -D_GNU_SOURCE

NETAID_SRCS := $(wildcard *.c)

HEADERS := ethlink.h helpers.h interfaces.h ipaddr.h iproute.h libnetlink.h ll_map.h \
	netproc.h sbuf.h

NETAID_OBJ   := $(patsubst %.c,$(BUILD)/%.o,$(NETAID_SRCS))

VERSION := 1.3

VERSION_MAJOR := 1
VERSION_MINOR := 0
VERSION_PATCH := 1

NETAID := libnetaid.so
NETAID_SO := libnetaid.so.$(VERSION_MAJOR)
NETAID_LIB := libnetaid.so.$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)

BINDIR ?= $(DESTDIR)/$(PREFIX)/bin
LIBDIR ?= $(DESTDIR)$(PREFIX)/lib/$(DEB_HOST_MULTIARCH)
INCLUDE_DIR ?= $(DESTDIR)$(INCLUDE_PREFIX)/include/simple-netaid
PKGCONFIGDIR ?= $(DESTDIR)$(PREFIX)/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

BUILD_NETAID_LIB := $(patsubst %,$(BUILD)$(LIBDIR)/%,$(NETAID_LIB))
INSTALL_NETAID_LIB := $(patsubst $(BUILD)$(LIBDIR)/%,$(LIBDIR)/%,$(BUILD_NETAID_LIB))

BUILD_NETAID_SO := $(patsubst %,$(BUILD)$(LIBDIR)/%,$(NETAID_SO))
INSTALL_NETAID_SO := $(patsubst $(BUILD)$(LIBDIR)/%,$(LIBDIR)/%,$(BUILD_NETAID_SO))

BUILD_NETAID := $(patsubst %,$(BUILD)$(LIBDIR)/%,$(NETAID))
INSTALL_NETAID := $(patsubst $(BUILD)$(LIBDIR)/%,$(LIBDIR)/%,$(BUILD_NETAID))

BUILD_HEADERS := $(patsubst %,$(BUILD)/$(INCLUDE_DIR)/%,$(HEADERS))
INSTALL_HEADERS := $(patsubst $(BUILD)/$(INCLUDE_DIR)/%,$(INCLUDE_DIR)/%,$(BUILD_HEADERS))

BUILD_PC_FILE := $(BUILD)$(PKGCONFIGDIR)/libnetaid.pc
INSTALL_PC_FILE := $(PKGCONFIGDIR)/libnetaid.pc

all: libs

libs: $(BUILD_HEADERS) $(BUILD_PC_FILE) $(BUILD_NETAID) $(BUILD_NETAID_SO) $(BUILD_NETAID_LIB)

$(BUILD_PC_FILE): libnetaid.pc.in
	@mkdir -p "$(shell dirname "$@")"
	@cat $< | \
		sed -e 's~@prefix@~$(PREFIX)~g;' | \
		sed -e 's~@includedir@~$(INCLUDE_DIR)~g;' | \
		sed -e 's~@version@~$(VERSION)~g; ' | \
		sed -e 's~@libdir@~$(LIBDIR)~g; ' > $@

$(BUILD_NETAID_LIB): $(NETAID_OBJ)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) -shared -Wl,-soname,$(NETAID_SO) -o "$@" $(NETAID_OBJ) $(LIBINC) -lm -liw

$(BUILD_NETAID_SO): $(BUILD_NETAID_LIB)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(BUILD_NETAID): $(BUILD_NETAID_SO)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(BUILD)/$(INCLUDE_DIR)/%.h: %.h
	@mkdir -p "$(shell dirname "$@")"
	@cp -a "$<" "$@"

$(INSTALL_NETAID): $(BUILD_NETAID)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INSTALL_NETAID_SO): $(BUILD_NETAID_SO)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INSTALL_NETAID_LIB): $(BUILD_NETAID_LIB)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INCLUDE_DIR)/%.h: $(BUILD)/$(INCLUDE_DIR)/%.h
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INSTALL_PC_FILE): $(BUILD_PC_FILE)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

libs-install: $(INSTALL_NETAID) $(INSTALL_NETAID_SO) $(INSTALL_NETAID_LIB) \
	$(INSTALL_PC_FILE)

headers-install: $(INSTALL_HEADERS)

install: libs-install headers-install

$(BUILD)/%.o : %.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) -o "$@" $(LIBINC) -c "$<"

.PHONY: clean
clean:
	rm -f $(BUILD_HEADERS) $(BUILD_NETAID_LIB) $(BUILD_NETAID_SO) $(BUILD_NETAID) \
		$(BUILD_PC_FILE) $(BUILD_HEADERS) $(NETAID_OBJ)
	rm -rf $(BUILD)

.PHONY: uninstall 
uninstall:
	rm -f $(INSTALL_HEADERS) $(INSTALL_NETAID_LIB) $(INSTALL_NETAID_SO) $(INSTALL_NETAID) \
		$(INSTALL_PC_FILE)

print-%: ; @echo $*=$($*)

=== debian/changelog ===
libnetaid (1.5.3-1+6genuen1) unstable; urgency=medium

  * Add support in iproute.c for IPv6 and point to point tunnels
  * New upstream version 1.5.3

 -- Aitor <aitor@genuen.org>  Sun, 25 Jan 2026 19:38:11 +0100

libnetaid (1.5.2-1+5gnuinos1) unstable; urgency=medium

  * Remove superfluous header <net/if.h> that generates conflicts under 32 bit
  * New upstream version 1.5.2

 -- Aitor <aitor_czr@gnuinos.org>  Wed, 17 Apr 2024 19:52:36 +0200

libnetaid (1.5.1-1+5gnuinos1) unstable; urgency=medium

  * Change version numbering scheme
  * Move conflictive header linux/if.h from ethlink.h to ethlink.c
  * Determine the path of ifquery before usage (require due to the 
    recent usr merge)
  * New upstream version 1.5.1

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 30 Mar 2024 09:06:45 +0100

libnetaid (1.5-1) unstable; urgency=medium

  * Fix segmentation fault
  * New upstream version 1.5

 -- Aitor <aitor_czr@gnuinos.org>  Tue, 05 Sep 2023 00:51:47 +0200

libnetaid (1.4-1) unstable; urgency=medium

  * Remove dependence on procps
  * New upstream version

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 20 May 2023 12:09:05 +0200

libnetaid (1.3-1) unstable; urgency=medium

  * Change to GNU Make build system.
  * Match package name with shared libraries soname.
  * Fix lintian errors and warnings.

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 11 Dec 2022 13:51:39 +0100

libnetaid (1.2-1) chimaera; urgency=medium

  * Move those helpers requiring system calls to snetaid
  * Removed the linux capkill capability in favor of OpenWRT's software bus, 
    implemented in snetaid (ubus). 
  * Fix some warnings in the returned values in print_route
  * New upstream version 1.2

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 27 Mar 2022 11:28:14 +0200

libnetaid (1.1-1) unstable; urgency=medium

  * Fix a bug getting the rtnh_flags in iproute.c
  * New upstream version 1.1

 -- Aitor <aitor_czr@gnuinos.org>  Fri, 04 Feb 2022 23:06:35 +0100

libnetaid (1.0-1) unstable; urgency=medium

  * Bump to 1.0

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 03 Oct 2021 02:43:38 +0200

libnetaid (0.1-1) unstable;  urgency=low

  * Initial release.

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 29 Feb 2020 11:22:01 +0100

=== debian/control ===
Source: libnetaid
Section: net
Priority: optional
Maintainer: Aitor Cuadrado Zubizarreta <aitor@genuen.org>
Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.16.1~), libiw-dev (>= 30~), libpstat-dev (>= 0.3-1~)
Standards-Version: 4.5.1
Origin: Genuen
Homepage: https://genuen.org

Package: libnetaid1
Section: libs
Architecture: linux-any
Multi-Arch: same
Conflicts: libnetaid, libnetaid0
Replaces: libnetaid, libnetaid0
Suggests: ifupdown, wpasupplicant
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, 
  libiw30 (>= 30~)
Description: Simple-netaid tools - library
 This package contains the shared libnetaid library.

Package: libnetaid-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libnetaid1 (= ${binary:Version}), libc6-dev, ${misc:Depends}
Description: Simple-netaid tools - development files
 This package contains the header files and static version of libnetaid.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1):
# - https://wiki.debian.org/Hardening#dpkg-buildflags

#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CFLAGS += -Wall -std=gnu99 -g -fPIC
export PREFIX=/usr

%:
	dh $@
